##########################################################
#                #                                       #
#	 ManyPage    #    See habille.pl / Voir habille.pl   #
#                #                                       #
##########################################################
#
# Ecriture des objets compiles
#

sub ecriture_obj
{
 local (*brut,*net,$path) = @_;

 open (BRUT,">$path/$Obj_brut_dest");
 open (NET,">$path/$Obj_net_dest");

 foreach $key (sort keys %brut)
  {
   print BRUT "<$key>\n";
   print BRUT $brut{$key};
   print BRUT "\n</$key>\n";
  } 

 foreach $key (sort keys %net)
  {
   print NET "<$key>\n";
   print NET $net{$key};
   print NET "\n</$key>\n";
  } 

 close (BRUT);
 close (NET);
}

sub lecture_final
{
 local ($name_file) =@_;
 local (%F_Brut) = ();
 local (%F_Net) = ();
 
 open (IN_BRUT, "$name_file/$Obj_brut_dest");
 open (IN_NET, "$name_file/$Obj_net_dest");

 print "lecture des objets compiles\n";

 while($Data_in = <IN_BRUT>)
  {
   if($Data_in =~ /<(.*?)>/is)
    {$Data_obj = $1;
	 while(!(($Data_in = <IN_BRUT>) =~ /.*<\/$Data_obj>.*/is))
	  {
	   $F_Brut{$Data_obj} .= $Data_in;
	  }
	 $F_Brut{$Data_obj} =~ s/\s*$//;
	}
  }

 while($Data_in = <IN_NET>)
  {
   if($Data_in =~ /<(.*?)>/is)
    {$Data_obj = $1;
	 while(!(($Data_in = <IN_NET>) =~ /.*<\/$Data_obj>.*/is))
	  {
	   $F_Net{$Data_obj} .= $Data_in;
	  }
	 $F_Net{$Data_obj} =~ s/\s*$//;
	}
  }

 local(@Les_Langues_Suf) = [];
 local(%Les_Langues_H) = ();
 (*Les_Langues_Suf,*Les_Langues_H) = &make_langue(%F_Net);

 close(IN_BRUT);
 close(IN_NET);

 return ({%F_Net},{%F_Brut},[@Les_Langues_Suf],{%Les_Langues_H}); 
}


return (1);
